//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "DelDocsDlg.h"
#include "mixmaster.h"
#include "global.h"
#include "helpdlg.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TDeleteDocsDlg *DeleteDocsDlg;
//---------------------------------------------------------------------------
void __fastcall ClearChosenDocuments(TForm *Owner)
{
   DeleteDocsDlg = new TDeleteDocsDlg(Owner);
   CenterDialog(DeleteDocsDlg,Owner);
   DeleteDocsDlg->ShowModal();
   delete DeleteDocsDlg;
}
//---------------------------------------------------------------------------
__fastcall TDeleteDocsDlg::TDeleteDocsDlg(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString md=MixDir();
   if (!FileExists(md+MListTxt)) MlistBox->Enabled = false;
   if (!FileExists(md+MRingTxt)) PubmixBox->Enabled = false;
   if (!FileExists(md+MTyp2Txt)) Type2Box->Enabled = false;
   if (!FileExists(md+CListTxt)) ClistBox->Enabled = false;
   if (!FileExists(md+CRingTxt)) PubascBox->Enabled = false;
   if (!FileExists(md+CTyp1Txt)) Type1Box->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TDeleteDocsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   int c=0;
   if (MlistBox->Checked) c++; if (PubmixBox->Checked) c++; if (Type2Box->Checked) c++;
   if (ClistBox->Checked) c++; if (PubascBox->Checked) c++; if (Type1Box->Checked) c++;
   if (c>0)
   {
      AnsiString md=MixDir(),plu=c>1?"s":"";
      switch(MsgBoxHwnd(Handle,
         s("You have checked ")+s(c)+s(" document")+plu+s(" for deletion.\n\n")+
         s("Are you sure?"),
         "Remailer Documents",
          MB_YESNOCANCEL))
      {
         case IDCANCEL: CanClose=false; break;
         case IDYES:
            if (MlistBox->Checked ) DeleteFile(s(md+MListTxt).c_str());
            if (PubmixBox->Checked) DeleteFile(s(md+MRingTxt).c_str());
            if (Type2Box->Checked ) DeleteFile(s(md+MTyp2Txt).c_str());
            if (ClistBox->Checked ) DeleteFile(s(md+CListTxt).c_str());
            if (PubascBox->Checked) DeleteFile(s(md+CRingTxt).c_str());
            if (Type1Box->Checked ) DeleteFile(s(md+CTyp1Txt).c_str());
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TDeleteDocsDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("RemailerClear","Deleteing Documents","",this);  
}
//---------------------------------------------------------------------------
