//---------------------------------------------------------------------------
#ifndef MainMDIH
#define MainMDIH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ComCtrls.hpp>
#include "FileMan.h"
#include "Global.h"
#include "explbtn.hpp"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
   TMenuItem *N1;
   TMenuItem *N2;
   TMenuItem *N3;
   TMenuItem *N4;
   TMenuItem *N6;
   TMenuItem *N8;
   TMenuItem *N9;
   TMenuItem *N10;
   TMenuItem *N11;
  TMenuItem *ClipboardN1Item;
  TMenuItem *Ed0;
  TMenuItem *Ed1;
  TMenuItem *Ed2;
  TMenuItem *Ed3;
  TMenuItem *Ed4;
  TMenuItem *Ed5;
   TPanel *Panel1;
   TOpenDialog *OpenDialog;
   TSaveDialog *SaveDialog;
   TMainMenu *MainMenu;
   TMenuItem *FileMenu;
   TMenuItem *FileOpenItem;
   TMenuItem *FileSendMessageItem;
   TMenuItem *FileQueueItem;
   TMenuItem *FileOpenQueueItem;
   TMenuItem *FileTemplatesItem;
   TMenuItem *FileSaveItem;
   TMenuItem *FileSaveAsItem;
   TMenuItem *FileSaveAsDefaultItem;
   TMenuItem *FileSaveAsDefMessageItem;
   TMenuItem *FileSaveAsDefArticleItem;
   TMenuItem *FileSaveAsTemplateItem;
   TMenuItem *FileNewArticleItem;
   TMenuItem *FileNewNoteItem;
   TMenuItem *FileMiscMessagesItem;
   TMenuItem *FilePrintItem;
   TMenuItem *FilePackDatabaseItem;
   TMenuItem *FileSecureModeItem;
   TMenuItem *FileExitItem;
   TMenuItem *FileNewMenu;
   TMenuItem *FileNewMessageItem;
   TMenuItem *FileNotesItem;
   TMenuItem *ViewMenu;
   TMenuItem *ViewMListTxtItem;
  TMenuItem *ViewPubringMixItem;
   TMenuItem *ViewType2ListItem;
   TMenuItem *ViewRListTxtItem;
   TMenuItem *ViewPubringAscItem;
   TMenuItem *ToolsMenu;
   TMenuItem *ToolsAddressBookItem;
   TMenuItem *ToolsRemailersItem;
   TMenuItem *ToolsUpdateonSendItem;
   TMenuItem *MailboxMenu;
   TMenuItem *MailboxMailboxesItem;
   TMenuItem *ClipboardMenu;
   TMenuItem *ClipboardFollowupItem;
   TMenuItem *ClipboardReplyItem;
   TMenuItem *ViewErrLogItem;
   TMenuItem *WindowMenu;
   TMenuItem *WindowTileItem;
   TMenuItem *WindowCascadeItem;
   TMenuItem *WindowArrangeIconsItem;
   TMenuItem *HelpMenu;
   TMenuItem *HelpAboutItem;
   TStatusBar *StatusBar;
   TBevel *Bevel1; TBevel *Bevel2; TBevel *Bevel3; TBevel *Bevel4;
   TMenuItem *FileOpenDataItem;
   TMenuItem *ViewMixcfgItem;
   TMenuItem *FileProblemsItem;
   TMenuItem *ToolsNymWizardItem;
   TSpeedButton *SpeedButton1;
   TMenuItem *HelpGettingStartedItem;
   TMenuItem *OpenMenu;
   TMenuItem *Preferences1;
	 TMenuItem *MailboxOutboxItem;
   TMenuItem *MailboxNewItem;
   TTimer *SendTimer;
   TMenuItem *FileCheckMailItem;
  TMenuItem *MailboxInboxItem;
  TMenuItem *FileSMTPLogItem;
  TMenuItem *ClipboardReceiveItem;
  TMenuItem *HelpN7Item;
  TMenuItem *HelpUpdateItem;
  TMenuItem *ToolsPopAccountsItem;
  TMenuItem *HelpQuickPop3Item;
  TMenuItem *HelpN12Item;
  TMenuItem *FileSessionLogsItem;
  TMenuItem *SessionLogsPOP3Item;
  TMenuItem *SessionLogsSMTPItem;
  TMenuItem *N7;
  TMenuItem *FileNewBugReport;
  TMenuItem *PgpMenu;
  TMenuItem *PgpLaunchKeysItem;
  TMenuItem *PgpPreferencesItem;
  TTimer *Timer1;
  TMenuItem *N12;
  TMenuItem *ToolsOptionsItems;
  TBevel *Bevel7;
  TCheckBox *UpdateStatsBox;
  TOfficeButton *OfficeButton1;
  TExplorerButton *ExplorerButton1;
  TOfficeButton *NewMessageBtn;
  TOfficeButton *NewArticleBtn;
  TOfficeButton *OfficeButton2;
  TOfficeButton *OpenTemplateBtn;
  TBevel *Bevel6;
  TOfficeButton *OpenDraftBtn;
  TOfficeButton *OpenNoteBtn;
  TOfficeButton *OpenQueueBtn;
  TBevel *Bevel8;
  TOfficeButton *OpenProbsBtn;
  TOfficeButton *CheckMailBtn;
  TBevel *Bevel9;
  TOfficeButton *OfficeButton3;
  TBevel *Bevel10;
  TOfficeButton *AddressBookBtn;
  TOfficeButton *RemailerBtn;
  TBevel *Bevel12;
  TOfficeButton *InBoxBtn;
  TOfficeButton *OfficeButton5;
  TOfficeButton *OptionsBtn;
  TMenuItem *ViewType1ListItem;
  TMenuItem *HelpQuickPgpItem;
  TMenuItem *N13;
  TMenuItem *ViewClearItem;
  TMenuItem *SessionLogsErrorCheckItem;
  TMenuItem *ViewChainLogItem;
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall ViewMixmasterFileItemClick(TObject *Sender);
   void __fastcall ToolsAddressBookItemClick(TObject *Sender);
   void __fastcall ToolsRemailersItemClick(TObject *Sender);
   void __fastcall ToolsUpdateonSendItemClick(TObject *Sender);
   void __fastcall FileNotesItemClick(TObject *Sender);
   void __fastcall MailboxMailboxesItemClick(TObject *Sender);
   void __fastcall FileNewMessageItemClick(TObject *Sender);
   void __fastcall FileNewArticleItemClick(TObject *Sender);
   void __fastcall FileMenuClick(TObject *Sender);
   void __fastcall FileSecureModeItemClick(TObject *Sender);
   void __fastcall FilePackDatabaseItemClick(TObject *Sender);
   void __fastcall FileOpenQueueItemClick(TObject *Sender);
   void __fastcall FileQueueItemClick(TObject *Sender);
   void __fastcall FileOpenItemClick(TObject *Sender);
   void __fastcall FileExitItemClick(TObject *Sender);
   void __fastcall FileSaveAsItemClick(TObject *Sender);
   void __fastcall FileSaveItemClick(TObject *Sender);
   void __fastcall FileSaveAsDefMessageItemClick(TObject *Sender);
   void __fastcall FileSaveAsDefArticleItemClick(TObject *Sender);
   void __fastcall FileSaveAsTemplateItemClick(TObject *Sender);
   void __fastcall FilePrintItemClick(TObject *Sender);
   void __fastcall FileNewNoteItemClick(TObject *Sender);
   void __fastcall FileSendMessageItemClick(TObject *Sender);
   void __fastcall FileTemplatesItemClick(TObject *Sender);
   void __fastcall WindowItemClick(TObject *Sender);
   void __fastcall WindowMenuClick(TObject *Sender);
   void __fastcall ClipboardMenuClick(TObject *Sender);
   void __fastcall ClipboardReplyItemClick(TObject *Sender);
   void __fastcall ClipboardFollowupItemClick(TObject *Sender);
   void __fastcall HelpAboutItemClick(TObject *Sender);
   void __fastcall EditBtnClick(TObject *Sender);
   void __fastcall StatusBarResize(TObject *Sender);
   void __fastcall FormDestroy(TObject *Sender);
   void __fastcall UpdateStatsBoxClick(TObject *Sender);
   void __fastcall Panel1Resize(TObject *Sender);
   void __fastcall FileOpenDataItemClick(TObject *Sender);
   void __fastcall FileProblemsItemClick(TObject *Sender);
   void __fastcall ViewLastSMTPLogItemClick(TObject *Sender);
   void __fastcall ViewMenuClick(TObject *Sender);
   void __fastcall HelpGettingStartedItemClick(TObject *Sender);
   void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
   void __fastcall Preferences1Click(TObject *Sender);
   void __fastcall ViewErrLogItemClick(TObject *Sender);
   void __fastcall MailboxOutboxItemClick(TObject *Sender);
   void __fastcall MailboxNewItemClick(TObject *Sender);
   void __fastcall FileSMTPLogItemClick(TObject *Sender);
   void __fastcall SendTimerTimer(TObject *Sender);
   void __fastcall FilePOP3LogItemClick(TObject *Sender);
   void __fastcall FileCheckMailItemClick(TObject *Sender);
   void __fastcall MailboxInboxItemClick(TObject *Sender);
   void __fastcall CheckBtnClick(TObject *Sender);
   void __fastcall ClipboardReceiveItemClick(TObject *Sender);
   void __fastcall HelpUpdateItemClick(TObject *Sender);
   void __fastcall ToolsPopAccountsItemClick(TObject *Sender);
   void __fastcall HelpQuickPop3ItemClick(TObject *Sender);
   void __fastcall HelpMenuClick(TObject *Sender);
   void __fastcall FileNewBugReportClick(TObject *Sender);
   void __fastcall Timer1Timer(TObject *Sender);
   void __fastcall ToolsOptionsItemsClick(TObject *Sender);
   void __fastcall InBoxBtnClick(TObject *Sender);
   void __fastcall OfficeButton5Click(TObject *Sender);
   void __fastcall OptionsBtnClick(TObject *Sender);
   void __fastcall HelpQuickPgpItemClick(TObject *Sender);
   void __fastcall ViewClearItemClick(TObject *Sender);
   void __fastcall SessionLogsErrorCheckItemClick(TObject *Sender);
   void __fastcall ViewChainLogClick(TObject *Sender);
  
private:	// User declarations
   void __fastcall ShowHint(TObject *Sender);
public:	// User declarations
   //TMenuItem *EditMenu;
   TDateTime DatTime;
   AnsiString winpos;//,MixDirOrg;
   TStrings *Message;
   TStringList *ProcessLog,*ErrorLog;
   AnsiString RunProgramOnExit;
   __fastcall TMainForm(TComponent* Owner);
   __fastcall virtual ~TMainForm();
   //void __fastcall EditTextFile(AnsiString &FileName);
   void __fastcall DisplayStatus(AnsiString &status, AnsiString &other=AnsiString(""));
   void __fastcall DisplayXY(long X, long Y);
   bool __fastcall IsEncrypted();
   void __fastcall MailboxItemOnClick(TObject *Sender);
   void __fastcall LoadMailboxMenu();
   void __fastcall SetMenus(bool children=true);
   void __fastcall NewMessage();
   void __fastcall NewArticle();
   void __fastcall FileOpen(AnsiString fromSection);
   void __fastcall FileSave(AnsiString toSection);
   void __fastcall SetButtons(bool enable);
   void __fastcall ShowInitValues(); // sanity check on init values
   bool __fastcall CheckRegkeyExists();
   bool __fastcall CheckAppiniExists();
   //bool __fastcall DotIniKeyExists(AnsiString &Key); // note '.ini' has vals
   //bool __fastcall MixRegKeyExists();
   HINSTANCE __fastcall CheckMixmasterInstall(bool &shutdown);
   void __fastcall SetNoMixmaster(); // disables menus, btns, etc if no mix
   HINSTANCE __fastcall CheckQSPgpInstall();
   HINSTANCE __fastcall CheckQSPop3Install();
   void __fastcall SavePOP3Log(WORD count, TStrings *log);
   void __fastcall SetNoPop3();
   void __fastcall SetNoPgp();
   HINSTANCE __fastcall CheckUPDateInstall();
   void __fastcall SetNoUpdate();
   bool __fastcall HasUpd();
   void __fastcall SafeStoreMixRandBin();
   bool __fastcall CheckMixrndExists();
   bool __fastcall MixZipExists();
   // Secure Mode
   bool __fastcall UnSecureData(TDataBuf *password);
   bool __fastcall SecureData(TDataBuf *password);
   // message functions
   void virtual __fastcall WMQueueChange(TMessage& Msg);
   void virtual __fastcall WMProblemChange(TMessage& Msg);
   void virtual __fastcall WMUpdateChecked(TMessage& Msg);
   void virtual __fastcall WMUpdateEnable(TMessage& Msg);
   void virtual __fastcall WMSetButtons(TMessage& Msg);
   void virtual __fastcall WMGetErrorLog(TMessage& Msg);
   void virtual __fastcall WMOpenProblems(TMessage& Msg);
   void virtual __fastcall WMOpenQueue(TMessage& Msg);
   void virtual __fastcall WMCheckUpdate(TMessage& Msg);
   void virtual __fastcall WMLoadMailboxMenu(TMessage& Msg);
   void virtual __fastcall WMInsertFilename(TMessage& Msg);
   void virtual __fastcall WMDisplayXY(TMessage& Msg);
   void virtual __fastcall WMIncomingMail(TMessage& Msg);
   void virtual __fastcall WMOpenInbox(TMessage& Msg);
   void virtual __fastcall WMStorePoplog(TMessage& Msg);
   void virtual __fastcall WMPopAccounts(TMessage& Msg);
   void virtual __fastcall WMSendMail(TMessage& Msg);
   void virtual __fastcall WMSetWinCursor(TMessage& Msg);
   void virtual __fastcall WMDatRequest(TMessage& Msg);
   void virtual __fastcall WMShowStatus(TMessage& Msg);
   void virtual __fastcall WMSaveQuit(TMessage& Msg);
   void virtual __fastcall WMSecureData(TMessage& Msg);
   void virtual __fastcall WMOpenAddresses(TMessage& Msg);
   void virtual __fastcall WMHelpWinPos(TMessage& Msg);
   //void virtual __fastcall WMEditMenu(TMessage& Msg);
   //void virtual __fastcall WMOpenHelp(TMessage& Msg);
   // message map
   BEGIN_MESSAGE_MAP
   MESSAGE_HANDLER(WM_QUEUECHANGE,TMessage,WMQueueChange)
   MESSAGE_HANDLER(WM_PROBLEMCHANGE,TMessage,WMProblemChange)
   MESSAGE_HANDLER(WM_UPDATECHECKED,TMessage,WMUpdateChecked)
   MESSAGE_HANDLER(WM_UPDATEENABLE,TMessage,WMUpdateEnable)
   MESSAGE_HANDLER(WM_CHECKUPDATE,TMessage,WMCheckUpdate)
   MESSAGE_HANDLER(WM_SETBUTTONS,TMessage,WMSetButtons)
   MESSAGE_HANDLER(WM_GETERRORLOG,TMessage,WMGetErrorLog)
   MESSAGE_HANDLER(WM_OPENPROBLEMS,TMessage,WMOpenProblems)
   MESSAGE_HANDLER(WM_OPENQUEUE,TMessage,WMOpenQueue)
   MESSAGE_HANDLER(WM_LOADBOXMENU,TMessage,WMLoadMailboxMenu)
   MESSAGE_HANDLER(WM_INSERTFILENAME,TMessage,WMInsertFilename)
   MESSAGE_HANDLER(WM_DISPLAYXY,TMessage,WMDisplayXY)
   MESSAGE_HANDLER(WM_INCOMINGMAIL,TMessage,WMIncomingMail)
   MESSAGE_HANDLER(WM_OPENINBOX,TMessage,WMOpenInbox)
   MESSAGE_HANDLER(WM_STOREPOPLOG,TMessage,WMStorePoplog)
   MESSAGE_HANDLER(WM_SENDMAIL,TMessage,WMSendMail)
   MESSAGE_HANDLER(WM_SETWINCURSOR,TMessage,WMSetWinCursor)
   MESSAGE_HANDLER(WM_DATREQUEST,TMessage,WMDatRequest)
   MESSAGE_HANDLER(WM_SHOWSTATUS,TMessage,WMShowStatus)
   MESSAGE_HANDLER(WM_SAVEQUIT,TMessage,WMSaveQuit)
   MESSAGE_HANDLER(WM_OPENADDRESSES,TMessage,WMOpenAddresses)
   MESSAGE_HANDLER(WM_HELPWINPOS,TMessage,WMHelpWinPos)

   //MESSAGE_HANDLER(WM_EDITMENU,TMessage,WMEditMenu)
   //MESSAGE_HANDLER(WM_OPENHELP,TMessage,WMOpenHelp)
   END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern TDataBuf *MasterPassword;
extern TMainForm *MainForm;
extern bool MessageTesting;
//---------------------------------------------------------------------------
#endif
