//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixThrd.h"
#include "global.h"
//#include "Mixmaster.h"
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TMixThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
__fastcall TMixThread::TMixThread(bool CreateSuspended)
  : TThread(CreateSuspended)
{
   Running = Finished = false;
}
//---------------------------------------------------------------------------
void __fastcall TMixThread::SetValsAndStart(int type, BUFFER *message, char *chain,
   int numcopies,BUFFER *feedback)
{
   Type = type;
   Message = message;
   Chain = chain;
   NumCopies = numcopies;
   Feedback = feedback;
   Result = -64;
   Resume();
}
//---------------------------------------------------------------------------
void __fastcall TMixThread::Execute()
{
// AnsiString tmp = (int)Result;
// MessageBox(NULL,tmp.c_str(),"Results2",MB_OK);
   Running = true;
   Result = mix_encrypt(Type,Message,Chain,NumCopies,Feedback);
   Finished = true;
}
//---------------------------------------------------------------------------
